Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/vector.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -898,12 +629,11 @@
  * \return true - success, false - vector is zero
  */
-bool Vector::MakeNormalVector(const Vector * const y1)
+bool Vector::MakeNormalTo(const Vector &y1)
 {
   bool result = false;
-  double factor = y1->ScalarProduct(this)/y1->NormSquared();
+  double factor = y1.ScalarProduct(*this)/y1.NormSquared();
   Vector x1;
-  x1.CopyVector(y1);
-  x1.Scale(factor);
-  SubtractVector(&x1);
+  x1 = factor * y1;
+  SubtractVector(x1);
   for (int i=NDIM;i--;)
     result = result || (fabs(x[i]) > MYEPSILON);
@@ -918,5 +648,5 @@
  * \return true - success, false - failure (null vector given)
  */
-bool Vector::GetOneNormalVector(const Vector * const GivenVector)
+bool Vector::GetOneNormalVector(const Vector &GivenVector)
 {
   int Components[NDIM]; // contains indices of non-zero components
@@ -925,30 +655,35 @@
   double norm;
 
-  Log() << Verbose(4);
-  GivenVector->Output();
-  Log() << Verbose(0) << endl;
   for (j=NDIM;j--;)
     Components[j] = -1;
+
+  // in two component-systems we need to find the one position that is zero
+  int zeroPos = -1;
   // find two components != 0
-  for (j=0;j<NDIM;j++)
-    if (fabs(GivenVector->x[j]) > MYEPSILON)
+  for (j=0;j<NDIM;j++){
+    if (fabs(GivenVector[j]) > MYEPSILON)
       Components[Last++] = j;
-  Log() << Verbose(4) << Last << " Components != 0: (" << Components[0] << "," << Components[1] << "," << Components[2] << ")" << endl;
+    else
+      // this our zero Position
+      zeroPos = j;
+  }
 
   switch(Last) {
     case 3:  // threecomponent system
+      // the position of the zero is arbitrary in three component systems
+      zeroPos = Components[2];
     case 2:  // two component system
-      norm = sqrt(1./(GivenVector->x[Components[1]]*GivenVector->x[Components[1]]) + 1./(GivenVector->x[Components[0]]*GivenVector->x[Components[0]]));
-      x[Components[2]] = 0.;
+      norm = sqrt(1./(GivenVector[Components[1]]*GivenVector[Components[1]]) + 1./(GivenVector[Components[0]]*GivenVector[Components[0]]));
+      at(zeroPos) = 0.;
       // in skp both remaining parts shall become zero but with opposite sign and third is zero
-      x[Components[1]] = -1./GivenVector->x[Components[1]] / norm;
-      x[Components[0]] = 1./GivenVector->x[Components[0]] / norm;
+      at(Components[1]) = -1./GivenVector[Components[1]] / norm;
+      at(Components[0]) = 1./GivenVector[Components[0]] / norm;
       return true;
       break;
     case 1: // one component system
       // set sole non-zero component to 0, and one of the other zero component pendants to 1
-      x[(Components[0]+2)%NDIM] = 0.;
-      x[(Components[0]+1)%NDIM] = 1.;
-      x[Components[0]] = 0.;
+      at((Components[0]+2)%NDIM) = 0.;
+      at((Components[0]+1)%NDIM) = 1.;
+      at(Components[0]) = 0.;
       return true;
       break;
@@ -958,111 +693,11 @@
 };
 
-/** Determines parameter needed to multiply this vector to obtain intersection point with plane defined by \a *A, \a *B and \a *C.
- * \param *A first plane vector
- * \param *B second plane vector
- * \param *C third plane vector
- * \return scaling parameter for this vector
- */
-double Vector::CutsPlaneAt(const Vector * const A, const Vector * const B, const Vector * const C) const
-{
-//  Log() << Verbose(3) << "For comparison: ";
-//  Log() << Verbose(0) << "A " << A->Projection(this) << "\t";
-//  Log() << Verbose(0) << "B " << B->Projection(this) << "\t";
-//  Log() << Verbose(0) << "C " << C->Projection(this) << "\t";
-//  Log() << Verbose(0) << endl;
-  return A->ScalarProduct(this);
-};
-
-/** Creates a new vector as the one with least square distance to a given set of \a vectors.
- * \param *vectors set of vectors
- * \param num number of vectors
- * \return true if success, false if failed due to linear dependency
- */
-bool Vector::LSQdistance(const Vector **vectors, int num)
-{
-  int j;
-
-  for (j=0;j<num;j++) {
-    Log() << Verbose(1) << j << "th atom's vector: ";
-    (vectors[j])->Output();
-    Log() << Verbose(0) << endl;
-  }
-
-  int np = 3;
-  struct LSQ_params par;
-
-   const gsl_multimin_fminimizer_type *T =
-     gsl_multimin_fminimizer_nmsimplex;
-   gsl_multimin_fminimizer *s = NULL;
-   gsl_vector *ss, *y;
-   gsl_multimin_function minex_func;
-
-   size_t iter = 0, i;
-   int status;
-   double size;
-
-   /* Initial vertex size vector */
-   ss = gsl_vector_alloc (np);
-   y = gsl_vector_alloc (np);
-
-   /* Set all step sizes to 1 */
-   gsl_vector_set_all (ss, 1.0);
-
-   /* Starting point */
-   par.vectors = vectors;
-   par.num = num;
-
-   for (i=NDIM;i--;)
-    gsl_vector_set(y, i, (vectors[0]->x[i] - vectors[1]->x[i])/2.);
-
-   /* Initialize method and iterate */
-   minex_func.f = &LSQ;
-   minex_func.n = np;
-   minex_func.params = (void *)&par;
-
-   s = gsl_multimin_fminimizer_alloc (T, np);
-   gsl_multimin_fminimizer_set (s, &minex_func, y, ss);
-
-   do
-     {
-       iter++;
-       status = gsl_multimin_fminimizer_iterate(s);
-
-       if (status)
-         break;
-
-       size = gsl_multimin_fminimizer_size (s);
-       status = gsl_multimin_test_size (size, 1e-2);
-
-       if (status == GSL_SUCCESS)
-         {
-           printf ("converged to minimum at\n");
-         }
-
-       printf ("%5d ", (int)iter);
-       for (i = 0; i < (size_t)np; i++)
-         {
-           printf ("%10.3e ", gsl_vector_get (s->x, i));
-         }
-       printf ("f() = %7.3f size = %.3f\n", s->fval, size);
-     }
-   while (status == GSL_CONTINUE && iter < 100);
-
-  for (i=(size_t)np;i--;)
-    this->x[i] = gsl_vector_get(s->x, i);
-   gsl_vector_free(y);
-   gsl_vector_free(ss);
-   gsl_multimin_fminimizer_free (s);
-
-  return true;
-};
-
 /** Adds vector \a *y componentwise.
  * \param *y vector
  */
-void Vector::AddVector(const Vector * const y)
-{
-  for (int i=NDIM;i--;)
-    this->x[i] += y->x[i];
+void Vector::AddVector(const Vector &y)
+{
+  for(int i=NDIM;i--;)
+    x[i] += y[i];
 }
 
@@ -1070,222 +705,9 @@
  * \param *y vector
  */
-void Vector::SubtractVector(const Vector * const y)
-{
-  for (int i=NDIM;i--;)
-    this->x[i] -= y->x[i];
-}
-
-/** Copy vector \a *y componentwise.
- * \param *y vector
- */
-void Vector::CopyVector(const Vector * const y)
-{
-  // check for self assignment
-  if(y!=this){
-    for (int i=NDIM;i--;)
-      this->x[i] = y->x[i];
-  }
-}
-
-/** Copy vector \a y componentwise.
- * \param y vector
- */
-void Vector::CopyVector(const Vector &y)
-{
-  // check for self assignment
-  if(&y!=this) {
-    for (int i=NDIM;i--;)
-      this->x[i] = y.x[i];
-  }
-}
-
-
-/** Asks for position, checks for boundary.
- * \param cell_size unitary size of cubic cell, coordinates must be within 0...cell_size
- * \param check whether bounds shall be checked (true) or not (false)
- */
-void Vector::AskPosition(const double * const cell_size, const bool check)
-{
-  char coords[3] = {'x','y','z'};
-  int j = -1;
-  for (int i=0;i<3;i++) {
-    j += i+1;
-    do {
-      Log() << Verbose(0) << coords[i] << "[0.." << cell_size[j] << "]: ";
-      cin >> x[i];
-    } while (((x[i] < 0) || (x[i] >= cell_size[j])) && (check));
-  }
-};
-
-/** Solves a vectorial system consisting of two orthogonal statements and a norm statement.
- * This is linear system of equations to be solved, however of the three given (skp of this vector\
- * with either of the three hast to be zero) only two are linear independent. The third equation
- * is that the vector should be of magnitude 1 (orthonormal). This all leads to a case-based solution
- * where very often it has to be checked whether a certain value is zero or not and thus forked into
- * another case.
- * \param *x1 first vector
- * \param *x2 second vector
- * \param *y third vector
- * \param alpha first angle
- * \param beta second angle
- * \param c norm of final vector
- * \return a vector with \f$\langle x1,x2 \rangle=A\f$, \f$\langle x1,y \rangle = B\f$ and with norm \a c.
- * \bug this is not yet working properly
- */
-bool Vector::SolveSystem(Vector * x1, Vector * x2, Vector * y, const double alpha, const double beta, const double c)
-{
-  double D1,D2,D3,E1,E2,F1,F2,F3,p,q=0., A, B1, B2, C;
-  double ang; // angle on testing
-  double sign[3];
-  int i,j,k;
-  A = cos(alpha) * x1->Norm() * c;
-  B1 = cos(beta + M_PI/2.) * y->Norm() * c;
-  B2 = cos(beta) * x2->Norm() * c;
-  C = c * c;
-  Log() << Verbose(2) << "A " << A << "\tB " << B1 << "\tC " << C << endl;
-  int flag = 0;
-  if (fabs(x1->x[0]) < MYEPSILON) { // check for zero components for the later flipping and back-flipping
-    if (fabs(x1->x[1]) > MYEPSILON) {
-      flag = 1;
-    } else if (fabs(x1->x[2]) > MYEPSILON) {
-       flag = 2;
-    } else {
-      return false;
-    }
-  }
-  switch (flag) {
-    default:
-    case 0:
-      break;
-    case 2:
-      flip(x1->x[0],x1->x[1]);
-      flip(x2->x[0],x2->x[1]);
-      flip(y->x[0],y->x[1]);
-      //flip(x[0],x[1]);
-      flip(x1->x[1],x1->x[2]);
-      flip(x2->x[1],x2->x[2]);
-      flip(y->x[1],y->x[2]);
-      //flip(x[1],x[2]);
-    case 1:
-      flip(x1->x[0],x1->x[1]);
-      flip(x2->x[0],x2->x[1]);
-      flip(y->x[0],y->x[1]);
-      //flip(x[0],x[1]);
-      flip(x1->x[1],x1->x[2]);
-      flip(x2->x[1],x2->x[2]);
-      flip(y->x[1],y->x[2]);
-      //flip(x[1],x[2]);
-      break;
-  }
-  // now comes the case system
-  D1 = -y->x[0]/x1->x[0]*x1->x[1]+y->x[1];
-  D2 = -y->x[0]/x1->x[0]*x1->x[2]+y->x[2];
-  D3 = y->x[0]/x1->x[0]*A-B1;
-  Log() << Verbose(2) << "D1 " << D1 << "\tD2 " << D2 << "\tD3 " << D3 << "\n";
-  if (fabs(D1) < MYEPSILON) {
-    Log() << Verbose(2) << "D1 == 0!\n";
-    if (fabs(D2) > MYEPSILON) {
-      Log() << Verbose(3) << "D2 != 0!\n";
-      x[2] = -D3/D2;
-      E1 = A/x1->x[0] + x1->x[2]/x1->x[0]*D3/D2;
-      E2 = -x1->x[1]/x1->x[0];
-      Log() << Verbose(3) << "E1 " << E1 << "\tE2 " << E2 << "\n";
-      F1 = E1*E1 + 1.;
-      F2 = -E1*E2;
-      F3 = E1*E1 + D3*D3/(D2*D2) - C;
-      Log() << Verbose(3) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
-      if (fabs(F1) < MYEPSILON) {
-        Log() << Verbose(4) << "F1 == 0!\n";
-        Log() << Verbose(4) << "Gleichungssystem linear\n";
-        x[1] = F3/(2.*F2);
-      } else {
-        p = F2/F1;
-        q = p*p - F3/F1;
-        Log() << Verbose(4) << "p " << p << "\tq " << q << endl;
-        if (q < 0) {
-          Log() << Verbose(4) << "q < 0" << endl;
-          return false;
-        }
-        x[1] = p + sqrt(q);
-      }
-      x[0] =  A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
-    } else {
-      Log() << Verbose(2) << "Gleichungssystem unterbestimmt\n";
-      return false;
-    }
-  } else {
-    E1 = A/x1->x[0]+x1->x[1]/x1->x[0]*D3/D1;
-    E2 = x1->x[1]/x1->x[0]*D2/D1 - x1->x[2];
-    Log() << Verbose(2) << "E1 " << E1 << "\tE2 " << E2 << "\n";
-    F1 = E2*E2 + D2*D2/(D1*D1) + 1.;
-    F2 = -(E1*E2 + D2*D3/(D1*D1));
-    F3 = E1*E1 + D3*D3/(D1*D1) - C;
-    Log() << Verbose(2) << "F1 " << F1 << "\tF2 " << F2 << "\tF3 " << F3 << "\n";
-    if (fabs(F1) < MYEPSILON) {
-      Log() << Verbose(3) << "F1 == 0!\n";
-      Log() << Verbose(3) << "Gleichungssystem linear\n";
-      x[2] = F3/(2.*F2);
-    } else {
-      p = F2/F1;
-      q = p*p - F3/F1;
-      Log() << Verbose(3) << "p " << p << "\tq " << q << endl;
-      if (q < 0) {
-        Log() << Verbose(3) << "q < 0" << endl;
-        return false;
-      }
-      x[2] = p + sqrt(q);
-    }
-    x[1] = (-D2 * x[2] - D3)/D1;
-    x[0] = A/x1->x[0] - x1->x[1]/x1->x[0]*x[1] + x1->x[2]/x1->x[0]*x[2];
-  }
-  switch (flag) { // back-flipping
-    default:
-    case 0:
-      break;
-    case 2:
-      flip(x1->x[0],x1->x[1]);
-      flip(x2->x[0],x2->x[1]);
-      flip(y->x[0],y->x[1]);
-      flip(x[0],x[1]);
-      flip(x1->x[1],x1->x[2]);
-      flip(x2->x[1],x2->x[2]);
-      flip(y->x[1],y->x[2]);
-      flip(x[1],x[2]);
-    case 1:
-      flip(x1->x[0],x1->x[1]);
-      flip(x2->x[0],x2->x[1]);
-      flip(y->x[0],y->x[1]);
-      //flip(x[0],x[1]);
-      flip(x1->x[1],x1->x[2]);
-      flip(x2->x[1],x2->x[2]);
-      flip(y->x[1],y->x[2]);
-      flip(x[1],x[2]);
-      break;
-  }
-  // one z component is only determined by its radius (without sign)
-  // thus check eight possible sign flips and determine by checking angle with second vector
-  for (i=0;i<8;i++) {
-    // set sign vector accordingly
-    for (j=2;j>=0;j--) {
-      k = (i & pot(2,j)) << j;
-      Log() << Verbose(2) << "k " << k << "\tpot(2,j) " << pot(2,j) << endl;
-      sign[j] = (k == 0) ? 1. : -1.;
-    }
-    Log() << Verbose(2) << i << ": sign matrix is " << sign[0] << "\t" << sign[1] << "\t" << sign[2] << "\n";
-    // apply sign matrix
-    for (j=NDIM;j--;)
-      x[j] *= sign[j];
-    // calculate angle and check
-    ang = x2->Angle (this);
-    Log() << Verbose(1) << i << "th angle " << ang << "\tbeta " << cos(beta) << " :\t";
-    if (fabs(ang - cos(beta)) < MYEPSILON) {
-      break;
-    }
-    // unapply sign matrix (is its own inverse)
-    for (j=NDIM;j--;)
-      x[j] *= sign[j];
-  }
-  return true;
-};
+void Vector::SubtractVector(const Vector &y)
+{
+  for(int i=NDIM;i--;)
+    x[i] -= y[i];
+}
 
 /**
@@ -1298,13 +720,18 @@
 bool Vector::IsInParallelepiped(const Vector &offset, const double * const parallelepiped) const
 {
-  Vector a;
-  a.CopyVector(this);
-  a.SubtractVector(&offset);
+  Vector a = (*this)-offset;
   a.InverseMatrixMultiplication(parallelepiped);
   bool isInside = true;
 
   for (int i=NDIM;i--;)
-    isInside = isInside && ((a.x[i] <= 1) && (a.x[i] >= 0));
+    isInside = isInside && ((a[i] <= 1) && (a[i] >= 0));
 
   return isInside;
 }
+
+
+// some comonly used vectors
+const Vector zeroVec(0,0,0);
+const Vector e1(1,0,0);
+const Vector e2(0,1,0);
+const Vector e3(0,0,1);
Index: src/vector.hpp
===================================================================
--- src/vector.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/vector.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,5 +15,8 @@
 #include <gsl/gsl_multimin.h>
 
+#include <memory>
+
 #include "defs.hpp"
+#include "Space.hpp"
 
 /********************************************** declarations *******************************/
@@ -22,76 +25,95 @@
  * basically, just a x[3] but with helpful functions
  */
-class Vector {
-  public:
-    double x[NDIM];
+class Vector : public Space{
+protected:
+  // this struct is used to indicate calls to the Baseconstructor from inside vectors.
+  struct Baseconstructor{};
+public:
 
   Vector();
   Vector(const double x1, const double x2, const double x3);
-  ~Vector();
+  Vector(const Vector& src);
+  virtual ~Vector();
 
-  double Distance(const Vector * const y) const;
-  double DistanceSquared(const Vector * const y) const;
-  double DistanceToPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset) const;
-  double PeriodicDistance(const Vector * const y, const double * const cell_size) const;
-  double PeriodicDistanceSquared(const Vector * const y, const double * const cell_size) const;
-  double ScalarProduct(const Vector * const y) const;
-  double Norm() const;
-  double NormSquared() const;
-  double Angle(const Vector * const y) const;
+  // Method implemented by forwarding to the Representation
+
+  double DistanceSquared(const Vector &y) const;
+  Vector GetDistanceVectorToPlane(const Vector &PlaneNormal, const Vector &PlaneOffset) const;
+  double DistanceToPlane(const Vector &PlaneNormal, const Vector &PlaneOffset) const;
+  double PeriodicDistance(const Vector &y, const double * const cell_size) const;
+  double PeriodicDistanceSquared(const Vector &y, const double * const cell_size) const;
+  double ScalarProduct(const Vector &y) const;
+  double Angle(const Vector &y) const;
   bool IsZero() const;
   bool IsOne() const;
-  bool IsNormalTo(const Vector * const normal) const;
-  bool IsEqualTo(const Vector * const a) const;
+  bool IsNormalTo(const Vector &normal) const;
+  bool IsEqualTo(const Vector &a) const;
 
-  void AddVector(const Vector * const y);
-  void SubtractVector(const Vector * const y);
-  void CopyVector(const Vector * const y);
-  void CopyVector(const Vector &y);
-  void RotateVector(const Vector * const y, const double alpha);
-  void VectorProduct(const Vector * const y);
-  void ProjectOntoPlane(const Vector * const y);
-  void ProjectIt(const Vector * const y);
-  Vector Projection(const Vector * const y) const;
-  void Zero();
-  void One(const double one);
-  void Init(const double x1, const double x2, const double x3);
-  void Normalize();
-  void Translate(const Vector * const x);
-  void Mirror(const Vector * const x);
-  void Scale(const double ** const factor);
-  void Scale(const double * const factor);
+  void AddVector(const Vector &y);
+  void SubtractVector(const Vector &y);
+  void VectorProduct(const Vector &y);
+  void ProjectOntoPlane(const Vector &y);
+  void ProjectIt(const Vector &y);
+  Vector Projection(const Vector &y) const;
+  void Mirror(const Vector &x);
+  void ScaleAll(const double *factor);
   void Scale(const double factor);
   void MatrixMultiplication(const double * const M);
-  void InverseMatrixMultiplication(const double * const M);
+  bool InverseMatrixMultiplication(const double * const M);
   void KeepPeriodic(const double * const matrix);
-  void LinearCombinationOfVectors(const Vector * const x1, const Vector * const x2, const Vector * const x3, const double * const factors);
-  double CutsPlaneAt(const Vector * const A, const Vector * const B, const Vector * const C) const;
-  bool GetIntersectionWithPlane(const Vector * const PlaneNormal, const Vector * const PlaneOffset, const Vector * const Origin, const Vector * const LineVector);
-  bool GetIntersectionOfTwoLinesOnPlane(const Vector * const Line1a, const Vector * const Line1b, const Vector * const Line2a, const Vector * const Line2b, const Vector *Normal = NULL);
-  bool GetOneNormalVector(const Vector * const x1);
-  bool MakeNormalVector(const Vector * const y1);
-  bool MakeNormalVector(const Vector * const y1, const Vector * const y2);
-  bool MakeNormalVector(const Vector * const x1, const Vector * const x2, const Vector * const x3);
-  bool SolveSystem(Vector * x1, Vector * x2, Vector * y, const double alpha, const double beta, const double c);
-  bool LSQdistance(const Vector ** vectors, int dim);
-  void AskPosition(const double * const cell_size, const bool check);
-  void Output() const;
+  bool GetOneNormalVector(const Vector &x1);
+  bool MakeNormalTo(const Vector &y1);
   bool IsInParallelepiped(const Vector &offset, const double * const parallelepiped) const;
   void WrapPeriodically(const double * const M, const double * const Minv);
 
-  Vector& operator=(const Vector &src);
+  // Accessors ussually come in pairs... and sometimes even more than that
+  double& operator[](size_t i);
+  const double& operator[](size_t i) const;
+  double& at(size_t i);
+  const double& at(size_t i) const;
+
+  // Assignment operator
+  Vector &operator=(const Vector& src);
+
+  // Access to internal structure
+  double* get();
+
+  // Methods that are derived directly from other methods
+  double Norm() const;
+  double NormSquared() const;
+  void Normalize();
+  void Zero();
+  void One(const double one);
+  void LinearCombinationOfVectors(const Vector &x1, const Vector &x2, const Vector &x3, const double * const factors);
+
+  // operators for mathematical operations
+  bool operator==(const Vector& b) const;
+  bool operator!=(const Vector& b) const;
+  const Vector& operator+=(const Vector& b);
+  const Vector& operator-=(const Vector& b);
+  Vector const operator+(const Vector& b) const;
+  Vector const operator-(const Vector& b) const;
+
+  // Methods inherited from Space
+  virtual double distance(const Vector &point) const;
+  virtual Vector getClosestPoint(const Vector &point) const;
+
+protected:
+
+private:
+  double x[NDIM];
 
 };
 
+// some commonly used and fixed vectors
+const extern Vector zeroVec;
+const extern Vector e1;
+const extern Vector e2;
+const extern Vector e3;
+
 ostream & operator << (ostream& ost, const Vector &m);
-bool operator==(const Vector& a, const Vector& b);
-Vector& operator+=(Vector& a, const Vector& b);
-Vector& operator-=(Vector& a, const Vector& b);
-Vector& operator*=(Vector& a, const double m);
-Vector& operator*(const Vector& a, const double m);
-Vector& operator*(const double m, const Vector& a);
-Vector& operator+(const Vector& a, const Vector& b);
-Vector& operator-(const Vector& a, const Vector& b);
-
+const Vector& operator*=(Vector& a, const double m);
+Vector const operator*(const Vector& a, const double m);
+Vector const operator*(const double m, const Vector& a);
 
 #endif /*VECTOR_HPP_*/
Index: src/vector_ops.cpp
===================================================================
--- src/vector_ops.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/vector_ops.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,241 @@
+/*
+ * vector_ops.cpp
+ *
+ *  Created on: Apr 1, 2010
+ *      Author: crueger
+ */
+
+#include "vector.hpp"
+#include "Plane.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+#include "gslmatrix.hpp"
+#include "leastsquaremin.hpp"
+#include "info.hpp"
+#include "Helpers/fast_functions.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
+
+#include <gsl/gsl_linalg.h>
+#include <gsl/gsl_matrix.h>
+#include <gsl/gsl_permutation.h>
+#include <gsl/gsl_vector.h>
+
+/**
+ * !@file
+ * These files defines several common operation on vectors that should not
+ * become part of the main vector class, because they are either to complex
+ * or need methods from other subsystems that should not be moved to
+ * the LinAlg-Subsystem
+ */
+
+/** Creates a new vector as the one with least square distance to a given set of \a vectors.
+ * \param *vectors set of vectors
+ * \param num number of vectors
+ * \return true if success, false if failed due to linear dependency
+ */
+bool LSQdistance(Vector &res,const Vector **vectors, int num)
+{
+  int j;
+
+  for (j=0;j<num;j++) {
+    Log() << Verbose(1) << j << "th atom's vector: " << vectors[j] << endl;
+  }
+
+  int np = 3;
+  struct LSQ_params par;
+
+   const gsl_multimin_fminimizer_type *T =
+     gsl_multimin_fminimizer_nmsimplex;
+   gsl_multimin_fminimizer *s = NULL;
+   gsl_vector *ss, *y;
+   gsl_multimin_function minex_func;
+
+   size_t iter = 0, i;
+   int status;
+   double size;
+
+   /* Initial vertex size vector */
+   ss = gsl_vector_alloc (np);
+   y = gsl_vector_alloc (np);
+
+   /* Set all step sizes to 1 */
+   gsl_vector_set_all (ss, 1.0);
+
+   /* Starting point */
+   par.vectors = vectors;
+   par.num = num;
+
+   for (i=NDIM;i--;)
+    gsl_vector_set(y, i, (vectors[0]->at(i) - vectors[1]->at(i))/2.);
+
+   /* Initialize method and iterate */
+   minex_func.f = &LSQ;
+   minex_func.n = np;
+   minex_func.params = (void *)&par;
+
+   s = gsl_multimin_fminimizer_alloc (T, np);
+   gsl_multimin_fminimizer_set (s, &minex_func, y, ss);
+
+   do
+     {
+       iter++;
+       status = gsl_multimin_fminimizer_iterate(s);
+
+       if (status)
+         break;
+
+       size = gsl_multimin_fminimizer_size (s);
+       status = gsl_multimin_test_size (size, 1e-2);
+
+       if (status == GSL_SUCCESS)
+         {
+           printf ("converged to minimum at\n");
+         }
+
+       printf ("%5d ", (int)iter);
+       for (i = 0; i < (size_t)np; i++)
+         {
+           printf ("%10.3e ", gsl_vector_get (s->x, i));
+         }
+       printf ("f() = %7.3f size = %.3f\n", s->fval, size);
+     }
+   while (status == GSL_CONTINUE && iter < 100);
+
+  for (i=(size_t)np;i--;)
+    res[i] = gsl_vector_get(s->x, i);
+   gsl_vector_free(y);
+   gsl_vector_free(ss);
+   gsl_multimin_fminimizer_free (s);
+
+  return true;
+};
+
+/** Rotates the vector relative to the origin around the axis given by \a *axis by an angle of \a alpha.
+ * \param *axis rotation axis
+ * \param alpha rotation angle in radian
+ */
+Vector RotateVector(const Vector &vec,const Vector &axis, const double alpha)
+{
+  Vector a,y;
+  Vector res;
+  // normalise this vector with respect to axis
+  a = vec;
+  a.ProjectOntoPlane(axis);
+  // construct normal vector
+  try {
+    y = Plane(axis,a,0).getNormal();
+  }
+  catch (MathException &excp) {
+    // The normal vector cannot be created if there is linar dependency.
+    // Then the vector to rotate is on the axis and any rotation leads to the vector itself.
+    return vec;
+  }
+  y.Scale(vec.Norm());
+  // scale normal vector by sine and this vector by cosine
+  y.Scale(sin(alpha));
+  a.Scale(cos(alpha));
+  res = vec.Projection(axis);
+  // add scaled normal vector onto this vector
+  res += y;
+  // add part in axis direction
+  res += a;
+  return res;
+};
+
+/** Calculates the intersection of the two lines that are both on the same plane.
+ * This is taken from Weisstein, Eric W. "Line-Line Intersection." From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/Line-LineIntersection.html
+ * \param *out output stream for debugging
+ * \param *Line1a first vector of first line
+ * \param *Line1b second vector of first line
+ * \param *Line2a first vector of second line
+ * \param *Line2b second vector of second line
+ * \return true - \a this will contain the intersection on return, false - lines are parallel
+ */
+Vector GetIntersectionOfTwoLinesOnPlane(const Vector &Line1a, const Vector &Line1b, const Vector &Line2a, const Vector &Line2b)
+{
+  Info FunctionInfo(__func__);
+
+  Vector res;
+
+  auto_ptr<GSLMatrix> M = auto_ptr<GSLMatrix>(new GSLMatrix(4,4));
+
+  M->SetAll(1.);
+  for (int i=0;i<3;i++) {
+    M->Set(0, i, Line1a[i]);
+    M->Set(1, i, Line1b[i]);
+    M->Set(2, i, Line2a[i]);
+    M->Set(3, i, Line2b[i]);
+  }
+
+  //Log() << Verbose(1) << "Coefficent matrix is:" << endl;
+  //for (int i=0;i<4;i++) {
+  //  for (int j=0;j<4;j++)
+  //    cout << "\t" << M->Get(i,j);
+  //  cout << endl;
+  //}
+  if (fabs(M->Determinant()) > MYEPSILON) {
+    Log() << Verbose(1) << "Determinant of coefficient matrix is NOT zero." << endl;
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+
+  Log() << Verbose(1) << "INFO: Line1a = " << Line1a << ", Line1b = " << Line1b << ", Line2a = " << Line2a << ", Line2b = " << Line2b << "." << endl;
+
+
+  // constuct a,b,c
+  Vector a = Line1b - Line1a;
+  Vector b = Line2b - Line2a;
+  Vector c = Line2a - Line1a;
+  Vector d = Line2b - Line1b;
+  Log() << Verbose(1) << "INFO: a = " << a << ", b = " << b << ", c = " << c << "." << endl;
+  if ((a.NormSquared() < MYEPSILON) || (b.NormSquared() < MYEPSILON)) {
+   res.Zero();
+   Log() << Verbose(1) << "At least one of the lines is ill-defined, i.e. offset equals second vector." << endl;
+   throw LinearDependenceException(__FILE__,__LINE__);
+  }
+
+  // check for parallelity
+  Vector parallel;
+  double factor = 0.;
+  if (fabs(a.ScalarProduct(b)*a.ScalarProduct(b)/a.NormSquared()/b.NormSquared() - 1.) < MYEPSILON) {
+    parallel = Line1a - Line2a;
+    factor = parallel.ScalarProduct(a)/a.Norm();
+    if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
+      res = Line2a;
+      Log() << Verbose(1) << "Lines conincide." << endl;
+      return res;
+    } else {
+      parallel = Line1a - Line2b;
+      factor = parallel.ScalarProduct(a)/a.Norm();
+      if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
+        res = Line2b;
+        Log() << Verbose(1) << "Lines conincide." << endl;
+        return res;
+      }
+    }
+    Log() << Verbose(1) << "Lines are parallel." << endl;
+    res.Zero();
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+
+  // obtain s
+  double s;
+  Vector temp1, temp2;
+  temp1 = c;
+  temp1.VectorProduct(b);
+  temp2 = a;
+  temp2.VectorProduct(b);
+  Log() << Verbose(1) << "INFO: temp1 = " << temp1 << ", temp2 = " << temp2 << "." << endl;
+  if (fabs(temp2.NormSquared()) > MYEPSILON)
+    s = temp1.ScalarProduct(temp2)/temp2.NormSquared();
+  else
+    s = 0.;
+  Log() << Verbose(1) << "Factor s is " << temp1.ScalarProduct(temp2) << "/" << temp2.NormSquared() << " = " << s << "." << endl;
+
+  // construct intersection
+  res = a;
+  res.Scale(s);
+  res += Line1a;
+  Log() << Verbose(1) << "Intersection is at " << res << "." << endl;
+
+  return res;
+};
Index: src/vector_ops.hpp
===================================================================
--- src/vector_ops.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/vector_ops.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,15 @@
+/*
+ * vector_ops.hpp
+ *
+ *  Created on: Apr 1, 2010
+ *      Author: crueger
+ */
+
+#ifndef VECTOR_OPS_HPP_
+#define VECTOR_OPS_HPP_
+
+bool LSQdistance(Vector &res,const Vector **vectors, int num);
+Vector RotateVector(const Vector &vec,const Vector &axis, const double alpha);
+Vector GetIntersectionOfTwoLinesOnPlane(const Vector &Line1a, const Vector &Line1b, const Vector &Line2a, const Vector &Line2b);
+
+#endif /* VECTOR_OPS_HPP_ */
Index: src/verbose.cpp
===================================================================
--- src/verbose.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/verbose.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -17,5 +17,5 @@
 
 /** States whether current output message should be print or not.
- * Compares Verbose::Verbosity against \a verbosityLevel.
+ * Compares Verbose::Verbosity plus Info::verbosity against \a verbosityLevel.
  * \param verbosityLevel given global level of verbosity
  * \return true - do output, false - don't
@@ -26,4 +26,13 @@
 };
 
+/** States whether current error output message should be print or not.
+ * Compares Verbose::Verbosity against \a verbosityLevel.
+ * \param verbosityLevel given global level of verbosity
+ * \return true - do output, false - don't
+ */
+bool Verbose::DoErrorOutput(int verbosityLevel) const
+{
+  return (verbosityLevel >= Verbosity);
+};
 
 /** Operator for the Verbose(arg) call.
Index: src/verbose.hpp
===================================================================
--- src/verbose.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/verbose.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -37,4 +37,5 @@
     ostream& print (ostream &ost) const;
     bool DoOutput(int verbosityLevel) const;
+    bool DoErrorOutput(int verbosityLevel) const;
   private:
     int Verbosity;
